import { type IFunctionType } from './types';
import { type IFirebaseFunction } from './IFirebaseFunction';
import { type IFirebaseRequest } from './IFirebaseRequest';
import { type IFirebaseSchedule } from './IFirebaseSchedule';
import { type IDatabaseScheme } from './database';
export type FirebaseDescriptor<DatabaseScheme extends IDatabaseScheme> = FirebaseDescriptor.Function<IFunctionType.Erased, unknown, DatabaseScheme> | FirebaseDescriptor.Request<IFunctionType.Erased, DatabaseScheme> | FirebaseDescriptor.Schedule<DatabaseScheme>;
export declare namespace FirebaseDescriptor {
    type Function<FunctionType extends IFunctionType.Erased, ResponseContext, DatabaseScheme extends IDatabaseScheme> = [IFirebaseFunction.Constructor<FunctionType, ResponseContext, DatabaseScheme>];
    type Request<FunctionType extends IFunctionType.Erased, DatabaseScheme extends IDatabaseScheme> = [IFirebaseRequest.Constructor<FunctionType, DatabaseScheme>, void];
    type Schedule<DatabaseScheme extends IDatabaseScheme> = [IFirebaseSchedule.Constructor<DatabaseScheme>, string, void];
    function _function<FunctionType extends IFunctionType.Erased, ResponseContext, DatabaseScheme extends IDatabaseScheme>(firebaseFunction: IFirebaseFunction.Constructor<FunctionType, ResponseContext, DatabaseScheme>): FirebaseDescriptor<DatabaseScheme>;
    function request<FunctionType extends IFunctionType.Erased, DatabaseScheme extends IDatabaseScheme>(firebaseRequest: IFirebaseRequest.Constructor<FunctionType, DatabaseScheme>): FirebaseDescriptor<DatabaseScheme>;
    function schedule<DatabaseScheme extends IDatabaseScheme>(schedule: string, firebaseSchedule: IFirebaseSchedule.Constructor<DatabaseScheme>): FirebaseDescriptor<DatabaseScheme>;
}
